package cn.iocoder.yudao.module.erp.service.autocode;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.erp.controller.admin.autocode.vo.*;
import cn.iocoder.yudao.module.erp.dal.dataobject.autocode.AutocodeRuleDO;
import cn.iocoder.yudao.module.erp.dal.mysql.autocode.AutocodeRuleMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import static cn.iocoder.yudao.module.erp.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link AutocodeRuleServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(AutocodeRuleServiceImpl.class)
public class AutocodeRuleServiceImplTest extends BaseDbUnitTest {

    @Resource
    private AutocodeRuleServiceImpl autocodeRuleService;

    @Resource
    private AutocodeRuleMapper autocodeRuleMapper;

    @Test
    public void testCreateAutocodeRule_success() {
        // 准备参数
        AutocodeRuleSaveReqVO createReqVO = randomPojo(AutocodeRuleSaveReqVO.class).setId(null);

        // 调用
        Long autocodeRuleId = autocodeRuleService.createAutocodeRule(createReqVO);
        // 断言
        assertNotNull(autocodeRuleId);
        // 校验记录的属性是否正确
        AutocodeRuleDO autocodeRule = autocodeRuleMapper.selectById(autocodeRuleId);
        assertPojoEquals(createReqVO, autocodeRule, "id");
    }

    @Test
    public void testUpdateAutocodeRule_success() {
        // mock 数据
        AutocodeRuleDO dbAutocodeRule = randomPojo(AutocodeRuleDO.class);
        autocodeRuleMapper.insert(dbAutocodeRule);// @Sql: 先插入出一条存在的数据
        // 准备参数
        AutocodeRuleSaveReqVO updateReqVO = randomPojo(AutocodeRuleSaveReqVO.class, o -> {
            o.setId(dbAutocodeRule.getId()); // 设置更新的 ID
        });

        // 调用
        autocodeRuleService.updateAutocodeRule(updateReqVO);
        // 校验是否更新正确
        AutocodeRuleDO autocodeRule = autocodeRuleMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, autocodeRule);
    }

    @Test
    public void testUpdateAutocodeRule_notExists() {
        // 准备参数
        AutocodeRuleSaveReqVO updateReqVO = randomPojo(AutocodeRuleSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> autocodeRuleService.updateAutocodeRule(updateReqVO), AUTOCODE_RULE_NOT_EXISTS);
    }

    @Test
    public void testDeleteAutocodeRule_success() {
        // mock 数据
        AutocodeRuleDO dbAutocodeRule = randomPojo(AutocodeRuleDO.class);
        autocodeRuleMapper.insert(dbAutocodeRule);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbAutocodeRule.getId();

        // 调用
        autocodeRuleService.deleteAutocodeRule(id);
       // 校验数据不存在了
       assertNull(autocodeRuleMapper.selectById(id));
    }

    @Test
    public void testDeleteAutocodeRule_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> autocodeRuleService.deleteAutocodeRule(id), AUTOCODE_RULE_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetAutocodeRulePage() {
       // mock 数据
       AutocodeRuleDO dbAutocodeRule = randomPojo(AutocodeRuleDO.class, o -> { // 等会查询到
           o.setRuleCode(null);
           o.setRuleName(null);
           o.setRuleDesc(null);
           o.setMaxLength(null);
           o.setIsPadded(null);
           o.setPaddedChar(null);
           o.setPaddedMethod(null);
           o.setRemark(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       autocodeRuleMapper.insert(dbAutocodeRule);
       // 测试 ruleCode 不匹配
       autocodeRuleMapper.insert(cloneIgnoreId(dbAutocodeRule, o -> o.setRuleCode(null)));
       // 测试 ruleName 不匹配
       autocodeRuleMapper.insert(cloneIgnoreId(dbAutocodeRule, o -> o.setRuleName(null)));
       // 测试 ruleDesc 不匹配
       autocodeRuleMapper.insert(cloneIgnoreId(dbAutocodeRule, o -> o.setRuleDesc(null)));
       // 测试 maxLength 不匹配
       autocodeRuleMapper.insert(cloneIgnoreId(dbAutocodeRule, o -> o.setMaxLength(null)));
       // 测试 isPadded 不匹配
       autocodeRuleMapper.insert(cloneIgnoreId(dbAutocodeRule, o -> o.setIsPadded(null)));
       // 测试 paddedChar 不匹配
       autocodeRuleMapper.insert(cloneIgnoreId(dbAutocodeRule, o -> o.setPaddedChar(null)));
       // 测试 paddedMethod 不匹配
       autocodeRuleMapper.insert(cloneIgnoreId(dbAutocodeRule, o -> o.setPaddedMethod(null)));
       // 测试 remark 不匹配
       autocodeRuleMapper.insert(cloneIgnoreId(dbAutocodeRule, o -> o.setRemark(null)));
       // 测试 isEnable 不匹配
       autocodeRuleMapper.insert(cloneIgnoreId(dbAutocodeRule, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       autocodeRuleMapper.insert(cloneIgnoreId(dbAutocodeRule, o -> o.setCreateTime(null)));
       // 准备参数
       AutocodeRulePageReqVO reqVO = new AutocodeRulePageReqVO();
       reqVO.setRuleCode(null);
       reqVO.setRuleName(null);
       reqVO.setRuleDesc(null);
       reqVO.setMaxLength(null);
       reqVO.setIsPadded(null);
       reqVO.setPaddedChar(null);
       reqVO.setPaddedMethod(null);
       reqVO.setRemark(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<AutocodeRuleDO> pageResult = autocodeRuleService.getAutocodeRulePage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbAutocodeRule, pageResult.getList().get(0));
    }

}